########################################################################
# Brake distance by Ray Krebs
# 
# Version:	1.1
# Date:		06.10.2016
########################################################################

import ac, acsys, sys, math

########################################################################
# adjust the size of the app, for example, scale = 1.0, scale = 1.5 ...
#
scale = 1.0
#
########################################################################




########################################################################
# global vars
#
appWindow=0
count=0
vmax=0
timeBase=0
ResetValues=0
FontSize=14	# Size ot fhe font
NextLine=20
brakeAktive=0	# Flag if brake was triggerd
distance=0	# Total driven distance
distance50=0	# Brake distance from 50km/h to 0
distance100=0	# Brake distance from 100km/h to 0
distance150=0	# Brake distance from 150km/h to 0
distance200=0	# Brake distance from 200km/h to 0
distance250=0	# Brake distance from 250km/h to 0
a250=0
a200=0
a150=0
a100=0
a50=0
TimeToHundred=0
TimeToTwoHundred=0
From80To120=0
v50=0
v100=0
v150=0
v200=0
v250=0
QMile=0
QDistance=0
QTime=0


########################################################################
# This function gets called by AC when the Plugin is initialised
# The function has to return a string with the plugin name
#
def acMain(ac_version):
   global speedLabel, brakeLabel, distanceLabel, Label, distance50Label, distance100Label, distance150Label, distance200Label
   global distance250Label, timeLabel, NextLine, ZeroToHundredLabel, ZeroToTwoHundredLabel, QuarterMileLabel, From80To120Label
   global v50, v100, v150, v200, v250, QMile

   appWindow = ac.newApp("Brake distance")
   ac.setSize(appWindow, 325*scale, 340*scale)
   
   # init
   v50=50.0/3.6
   v100=100.0/3.6
   v150=150.0/3.6
   v200=200.0/3.6
   v250=250.0/3.6
   QMile=1609.34/4.0

   # Speed
   NextLine = NextLine + 1.5*scale*FontSize
   speedLabel = ac.addLabel(appWindow, "Speed:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(speedLabel, 5, NextLine)
   ac.setFontSize(speedLabel, FontSize*scale)

   # Brake
   NextLine = NextLine + 1.5*scale*FontSize
   brakeLabel = ac.addLabel(appWindow, "Brake Level: 0.00                Gas Level: 0.00")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(brakeLabel, 5, NextLine)
   ac.setFontSize(brakeLabel, FontSize*scale)

   # Distance
   NextLine = NextLine + 1.5*scale*FontSize
   distanceLabel = ac.addLabel(appWindow, "Total Distance:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distanceLabel, 5, NextLine)
   ac.setFontSize(distanceLabel, FontSize*scale)

   # From 0 to 100 km/h
   NextLine = NextLine + 1.5*scale*FontSize
   NextLine = NextLine + 1.5*scale*FontSize
   ZeroToHundredLabel = ac.addLabel(appWindow, "From 0 to 100km/h:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(ZeroToHundredLabel, 5, NextLine)
   ac.setFontSize(ZeroToHundredLabel, FontSize*scale)

   # From 0 to 200 km/h
   NextLine = NextLine + 1.5*scale*FontSize
   ZeroToTwoHundredLabel = ac.addLabel(appWindow, "From 0 to 200km/h:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(ZeroToTwoHundredLabel, 5, NextLine)
   ac.setFontSize(ZeroToTwoHundredLabel, FontSize*scale)

   # From 80km/h to 120km/h
   NextLine = NextLine + 1.5*scale*FontSize
   From80To120Label = ac.addLabel(appWindow, "From 80km/h to 120km/h:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(From80To120Label, 5, NextLine)
   ac.setFontSize(From80To120Label, FontSize*scale)

   # From 0 to quarter mile
   NextLine = NextLine + 1.5*scale*FontSize
   QuarterMileLabel = ac.addLabel(appWindow, "From 0 to quarter mile:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(QuarterMileLabel, 5, NextLine)
   ac.setFontSize(QuarterMileLabel, FontSize*scale)

   # Brake distance from 250 km/h to 0
   NextLine = NextLine + 1.5*scale*FontSize
   distance250Label = ac.addLabel(appWindow, "Brake distance 250km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance250Label, 5, NextLine)
   ac.setFontSize(distance250Label, FontSize*scale)

   # Brake distance from 200 km/h to 0
   NextLine = NextLine + 1.5*scale*FontSize
   distance200Label = ac.addLabel(appWindow, "Brake distance 200km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance200Label, 5, NextLine)
   ac.setFontSize(distance200Label, FontSize*scale)
    
   # Brake distance from 150 km/h to 0
   NextLine = NextLine + 1.5*scale*FontSize
   distance150Label = ac.addLabel(appWindow, "Brake distance 150km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance150Label, 5, NextLine)
   ac.setFontSize(distance150Label, FontSize*scale)

   # Brake distance from 100 km/h to 0
   NextLine = NextLine + 1.5*scale*FontSize
   distance100Label = ac.addLabel(appWindow, "Brake distance 100km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance100Label, 5, NextLine)
   ac.setFontSize(distance100Label, FontSize*scale)

   # Brake distance from 50 km/h to 0
   NextLine = NextLine + 1.5*scale*FontSize
   distance50Label = ac.addLabel(appWindow, "Brake distance 50km/h to 0:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(distance50Label, 5, NextLine)
   ac.setFontSize(distance50Label, FontSize*scale)

   # Time Label
   NextLine = NextLine + 1.5*scale*FontSize
   timeLabel = ac.addLabel(appWindow, "Time:")
   # Position (Label, x-Pos, y-Pos)
   ac.setPosition(timeLabel, 5, NextLine)
   ac.setFontSize(timeLabel, FontSize*scale)

   ac.addRenderCallback(appWindow, onFormRender) 
   return "Brake distance"

########################################################################
# This function gets called every x-ms
#
def onFormRender(deltaT):
   global speedLabel, brakeLabel, distanceLabel, distance50Label, distance100Label, distance150Label, distance200Label, distance250Label, timeLabel, timeBase
   global OldXValue, OldYValue, OldZValue, count, distance, vmax, distance50, distance100, distance150, distance200, distance250, brakeAktive
   global ZeroToHundredLabel, ZeroToTwoHundredLabel, QuarterMileLabel, From80To120Label, From80To120
   global TimeToHundred, TimeToTwoHundred, ResetValues, a250, a200, a150, a100, a50, v50, v100, v150, v200, v250, QMile, QDistance, QTime

   # Get actual speed and save Vmax
   speedValueKMH = ac.getCarState(0, acsys.CS.SpeedKMH)
   if vmax < speedValueKMH:
      vmax = speedValueKMH

   # Display actual speed and Vmax
   ac.setText(speedLabel, "Speed: {:.0f} km/h                   Vmax: {:.0f} km/h".format(speedValueKMH,vmax))

   #Get actual Gas value
   gasValue = ac.getCarState(0, acsys.CS.Gas)

   # Get actual brake value
   brakeValue = ac.getCarState(0, acsys.CS.Brake)

   # Display actual brake value
   ac.setText(brakeLabel, "Brake Level: {:.2f}                Gas Level: {:.2f}".format(brakeValue, gasValue))
   if brakeValue != 0:
      brakeAktive=1

   # get the Vector of the world position and direction
   if count==0:
      OldXValue, OldYValue, OldZValue = ac.getCarState(0, acsys.CS.WorldPosition)
      count=1
   else:
      x, y, z = ac.getCarState(0, acsys.CS.WorldPosition)
      dx=x-OldXValue
      dy=y-OldYValue
      dz=z-OldZValue
      OldXValue=x
      OldYValue=y      
      OldZValue=z
      deltaQ=dx*dx+dy*dy+dz*dz
      delta=math.sqrt(deltaQ)
      distance=distance+delta
      count=count+1

   #################################
   # Brake
   #
   # Display total driven distance
   ac.setText(distanceLabel, "Total Distance: {:.2f} m".format(distance))

   # calculate distance 250 to 0 
   if brakeAktive==1 and speedValueKMH < 250 and vmax > 250:
      distance250=distance250+delta

   # Display brake and G from distance 250 to 0 
   ac.setText(distance250Label, "Brake distance 250km/h to 0: {:.2f} m   G: {:.2f}".format(distance250,a250))

   # calculate distance 200 to 0 
   if brakeAktive==1 and speedValueKMH < 200 and vmax > 200:
      distance200=distance200+delta

   # Display brake and G from distance 200 to 0 
   ac.setText(distance200Label, "Brake distance 200km/h to 0: {:.2f} m   G: {:.2f}".format(distance200,a200))

   # calculate distance 150 to 0 
   if brakeAktive==1 and speedValueKMH < 150 and vmax > 150:
      distance150=distance150+delta

   # Display brake an G from distance 150 to 0 
   ac.setText(distance150Label, "Brake distance 150km/h to 0: {:.2f} m   G: {:.2f}".format(distance150,a150))

   # calculate distance 100 to 0   
   if brakeAktive==1 and speedValueKMH < 100 and vmax > 100:
      distance100=distance100+delta

   # Display brake and G from distance 100 to 0
   ac.setText(distance100Label, "Brake distance 100km/h to 0: {:.2f} m   G: {:.2f}".format(distance100,a100))

   # calculate distance 50 to 0   
   if brakeAktive==1 and speedValueKMH < 50 and vmax > 50:
      distance50=distance50+delta

   # Display brake and G from distance 50 to 0
   ac.setText(distance50Label, "Brake distance 50km/h to 0: {:.2f} m   G: {:.2f}".format(distance50,a50))

   ##############################################
   # Accelerate
   #
   timeBase=timeBase+deltaT
   ac.setText(timeLabel, "Time: {:.3f} s".format(timeBase))

   # calculate from 0 to 100km/h 
   if speedValueKMH > 0.05 and speedValueKMH <= 100.0 and vmax <= 100.0:
      TimeToHundred = TimeToHundred+deltaT

   # Display from 0 to 100km/h
   ac.setText(ZeroToHundredLabel, "From 0 to 100km/h: {:.3f} s".format(TimeToHundred))

   # calculate from 80 to 120km/h 
   if speedValueKMH > 80.0 and speedValueKMH <= 120.0 and vmax <= 120.0:
      From80To120 = From80To120+deltaT

   # Display from 80 to 100km/h
   ac.setText(From80To120Label, "From 80 to 120km/h: {:.3f} s".format(From80To120))

   # calculate from 0 to 200km/h 
   if speedValueKMH > 0.05 and speedValueKMH <= 200.0 and vmax <= 200.0:
     TimeToTwoHundred = TimeToTwoHundred+deltaT

   # Display from 0 to 200km/h
   ac.setText(ZeroToTwoHundredLabel, "From 0 to 200km/h: {:.3f} s".format(TimeToTwoHundred))

   # calculate quarter mile
   if speedValueKMH > 0.05 and QDistance <= QMile:
      QDistance=QDistance+delta
      QTime=QTime+deltaT

   ac.setText(QuarterMileLabel, "From 0 to quarter mile: {:.3f} s running...".format(QTime))

   # Display quarter mile
   if(QDistance > QMile):
      ac.setText(QuarterMileLabel, "From 0 to quarter mile: {:.3f} s finsih".format(QTime))



   # Hold the distance when speed < 0.05
   if speedValueKMH < 0.05 and brakeAktive == 1:
      if(distance250 > 0):
         a250=(v250*v250/(2*distance250))/9.81

      if(distance200 > 0):
         a200=(v200*v200/(2*distance200))/9.81

      if(distance150 > 0):
         a150=(v150*v150/(2*distance150))/9.81

      if(distance100 > 0):
         a100=(v100*v100/(2*distance100))/9.81

      if(distance50 > 0):
         a50=(v50*v50/(2*distance50))/9.81
      
      ResetValues=1


   # Reset values
   if ResetValues == 1 and speedValueKMH > 0.05 and gasValue > 0.2:
      ResetValues=0
      brakeAktive=0
      #count=0
      #distance=0
      vmax=0
      distance50=0
      distance100=0
      distance150=0
      distance200=0
      distance250=0
      TimeToHundred=0
      TimeToTwoHundred=0
      From80To120=0
      QDistance=0
      QTime=0
      a250=0
      a200=0
      a150=0
      a100=0
      a50=0
